	
var LogUtil = {
	prefix: '', 
	enableDump: false,
	enableAppend: false,
	
	dump: function (strMsg) {
		var strLog = new Date() + "  " + strMsg + "\n";
		
		if (LogUtil.enableDump)
			window.dump(strLog);
		
		return strLog;
	},	
	
	debug: function (strMsg, objVal) {
		var strObj = null;
		
		if (typeof(objVal) == "string")
			strObj = objVal;
		else if (typeof(objVal) == "undefined")
			strObj = "undefined";
		else
			strObj = "JSON:\n" + LogUtil.encode(objVal);
		
		LogUtil.log(strMsg + "----" + strObj);
	},	
	
	log: function (strMsg) {
		var strMsg = LogUtil.dump(strMsg);
		
		var strPath = DirIO.get("ProfD").path + '/' + LogUtil.prefix + 'debug.log';
		
		if (LogUtil.enableAppend)
			LogUtil.append(strPath, strMsg);
	},	
	
	jsdump: function (str) {
		Components.classes['@mozilla.org/consoleservice;1']
			.getService(Components.interfaces.nsIConsoleService)
			.logStringMessage(str);
	},	
	
	append: function (strPath, strData) {
		var flOut = FileIO.open(strPath);
		
		if (!flOut.exists()) 
			FileIO.create(flOut);
		
		FileIO.write(flOut, strData, 'a');
	},	
	
	nativeEncode: function (objTrg) { // Exception not handling! Will fail much times with dom objects!!
		var nativeJSON = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);
		return nativeJSON.encode(objTrg);
	},	
	
	encode: function (objTrg, intDeep) {
		if (typeof(intDeep) == "undefined") intDeep = 2;
		
		return JSONUtil.encode(objTrg, '', intDeep);
	},	
	
	obj: function (objTrg) {
		LogUtil.log("JSON:\n" + LogUtil.encode(objTrg));
	}
};	
	
