	
var VipBookMark = {
	hookedPanel : false,
	panelActive : false,
	lastEnter : -1,
	originalPanel : null,
	lastCheck : -1,
	checkPeriod : 20000, 
	hasUser : false,
	
	init: function () {
		LogUtil.prefix = 'vipbookmark_';
		
		// Beállítja a wrapper függvényt, hogy bele szólhassunk a megjelenítésbe
		VipBookMark.originalPanel = StarUI._doShowEditBookmarkPanel;
		StarUI._doShowEditBookmarkPanel = VipBookMark.wrapper;
		
		LogUtil.debug("testobj", {name: "Hello", type: "NORMAL", count: 11});
	},	
	
	wrapper: function() {
		LogUtil.log("Show EditBookmarkPanel");
		
		//VipBookMark.hookBookmarkService();
		
		// Megjeleníti az eredeti panelt
		VipBookMark.originalPanel.apply(StarUI, arguments);
		
		VipBookMark.clean();
		VipBookMark.checkUser(VipBookMark.render);
		
		// ESC, ENTER és a panel eltüntetésének figyelése
		VipBookMark.hookPanel();
	},	
	
	clean: function () {
	},	
	
	render: function() {
		if (VipBookMark.hasUser) {
			if (DOMUtil.get("vpbm_Row1") == null) {
				LogUtil.log("Render rows");
				
				var objRow1 = 
					{_tag: "row", id: "vpbm_Row1", align: "center", _insertBefore: "editBMPanel_tagsRow", 
						lbl: {_tag: "label", value: "Könyvjelző.hu:"},
						chk: {_tag: "checkbox", id: "vpbm_Up", checked: "true"}
					};
				DOMUtil.create(objRow1);
				
				var objRow2 = 
					{_tag: "row", id: "vpbm_Row2", align: "center", _insertBefore: "editBMPanel_tagsRow", 
						lbl: {_tag: "label", value: "Prioritás:"},
						scl: {_tag: "scale", id: "vpbm_Prior", max: "5"}
					};
				DOMUtil.create(objRow2);
				
				var objRow3 = 
					{_tag: "row", id: "vpbm_Row3", align: "center", _insertBefore: "editBMPanel_tagsRow", 
						lbl: {_tag: "label", value: "Kategória:"},
						scl: {_tag: "textbox", id: "vpbm_Category"}
					};
				DOMUtil.create(objRow3);
				
				var objRow4 = 
				{_tag: "row", id: "vpbm_Row4", align: "center", _insertBefore: "editBMPanel_tagsRow", 
					lbl: {_tag: "label", value: "Publikus:"},
					chk: {_tag: "checkbox", id: "vpbm_Global", checked: "true"}
				};
				DOMUtil.create(objRow4);
			}
		} else {
			LogUtil.log("Remove rows");
			DOMUtil.remove("vpbm_Row1");
			DOMUtil.remove("vpbm_Row2");
			DOMUtil.remove("vpbm_Row3");
			DOMUtil.remove("vpbm_Row4");
		}
	},	
	
	hookPanel: function () {
		VipBookMark.panelActive = true;
		VipBookMark.lastEnter = -1;
		
		if (!VipBookMark.hookedPanel) {
			window.addEventListener("keypress", function (e) {
				if (VipBookMark.panelActive && e.keyCode == 13) 
					VipBookMark.lastEnter = new Date().getTime();
			}, true);
			
			var pnlBook = document.getElementById("editBookmarkPanel");
			
			pnlBook.addEventListener("popuphidden", function(e){
				VipBookMark.panelActive = false;
				
				var intTime = new Date().getTime();
				
				LogUtil.log(
					" ent: " + (intTime - VipBookMark.lastEnter) +
					" now: " + intTime
				);
				
				if ((intTime - VipBookMark.lastEnter) < 200)
					VipBookMark.onSave();
			},false);
			
			var btnDoneButton = document.getElementById("editBookmarkPanelDoneButton");
			btnDoneButton.addEventListener("command", VipBookMark.onSave, true);
			
			VipBookMark.hookedPanel = true;
		}
	},	
	
	
	/*
	 * TODO: editBMPanel_keywordField Show for Category
	 */
	onSave: function () {
		var blnGlobal = document.getElementById("vpbm_Global").checked;
		var blnSave = document.getElementById("vpbm_Up").checked;
		var strPrior = document.getElementById("vpbm_Prior").value;
		var strCategory = document.getElementById("vpbm_Category").value;
		var pnlEdit = document.getElementById("editBookmarkPanel").value;
		var strURL = document.getElementById("editBMPanel_locationField").value;
		var strTags = document.getElementById("editBMPanel_tagsField").value;
		var strTitle = document.getElementById("editBMPanel_namePicker").value;
		var httpRequest = null;
		
		LogUtil.debug("editBMPanel_namePicker", document.getElementById("editBMPanel_namePicker"));
		
		if (blnSave) {
			httpRequest = new XMLHttpRequest();
			
			strURL = "http://konyvjelzo.hu/common/service/requestparser?name=bkmadd"
				+ "&url=" + strURL
				+"&title=" + strTitle
				+"&cat=" + strCategory
				+"&tags=" + strTags
				+"&prior=" + strPrior
				+"&time=" + new Date().getTime()
				;
			
			if (blnGlobal)
				strURL += "&setglobal=yes";
			else
				strURL += "&setglobal=no";
			
			httpRequest.open("GET", strURL, true);
			httpRequest.onload = VipBookMark.sendBookmark;
			httpRequest.send(null);
		} else {
			LogUtil.log("Local URL");
		}
		
	    		 
		return false;
	},	
	
	sendBookmark: function () {
		LogUtil.log("URL Saved");
	},	
	
	checkUser: function (fncDo, fncFail) {
		var httpRequest = new XMLHttpRequest();
		var strURL = "http://konyvjelzo.hu/common/service/requestparser?name=usercheck&time=" 
			+ new Date().getTime();
		
		httpRequest.open("GET", strURL, true);
		
		httpRequest.onload = function (e) {
			LogUtil.debug("checkUser response", e.target.responseText);
			
			VipBookMark.lastCheck = new Date().getTime();
			VipBookMark.hasUser = (e.target.responseText.indexOf("LOGGED_IN") > -1);
			
			if (VipBookMark.hasUser) {
				LogUtil.debug("checkUser response", "TRUE");
				
				VipBookMark.setStatus("Logged In");
			} else {
				VipBookMark.setStatus("Logged Out");
			}
			
			fncDo();
		};	
		
		httpRequest.send(null);
	},	
	
	setStatus: function (strStatus) {
		var winMain = WindowUtil.get();
		var objStatus = winMain.document.getElementById("vipbookmarkStatusText");
		
		objStatus.value = strStatus;
	},	
	
	home: function () {
		// VipBookMark.go("http://konyvjelzo.hu/common/service/requestparser?name=user");
		VipBookMark.go("http://konyvjelzo.hu/tart/index");
	},	
	
	urls: function () {
		// VipBookMark.go("http://konyvjelzo.hu/common/service/requestparser?name=userurls");		
		VipBookMark.go("http://konyvjelzo.hu/tart/index");		
	},	
	
	go: function(strUrl) {
		VipBookMark.checkUser(function () {
			if (!VipBookMark.hasUser) {
				strUrl = "http://konyvjelzo.hu/tart/index?type=login";
			}
			
			var newTab = gBrowser.addTab(strUrl + "&time=" + new Date().getTime());
	  		gBrowser.selectedTab = newTab;
		});
	}	
};	
	
window.addEventListener("load", VipBookMark.init, false);
	
/*	
	hookBookmarkService: function () {
		if (VipBookMark.hookedPanel) {
			LogUtil.log("hookBookmarkService Register START");
		
			// Create a bookmark observer
			var observer = {
			  onBeginUpdateBatch: function() {
				// This method is notified when a batch of changes are about to occur.
				// Observers can use this to suspend updates to the user-interface, for example
				// while a batch change is occurring.
			LogUtil.log("onBeginUpdateBatch");
			  },
			  onEndUpdateBatch: function() {
				this._inBatch = false;
			LogUtil.log("onEndUpdateBatch");
			  },
			  onItemAdded: function(id, folder, index) {
			LogUtil.log("onItemAdded:" + id);
			  },
			  onItemRemoved: function(id, folder, index) {
			LogUtil.log("onItemRemoved:" + id);
			  },
			  onItemChanged: function(id, property, isAnnotationProperty, value) {
				// isAnnotationProperty is a boolean value that is true of the changed property is an annotation.
				// You can access a bookmark item's annotations with the <code>nsIAnnotationService</code>.
			LogUtil.log("onItemChanged:" + id);
			  },
			  onItemVisited: function(id, visitID, time) {
				// The visit id can be used with the History service to access other properties of the visit.
				// The time is the time at which the visit occurred, in microseconds.
			LogUtil.log("onItemVisited:" + id);
			  },
			  onItemMoved: function(id, oldParent, oldIndex, newParent, newIndex) {
				// oldParent and newParent are the ids of the old and new parent folders of the moved item.
			LogUtil.log("onItemMoved:" + id);
			  },
			  QueryInterface: function(iid) {
				if (iid.equals(Ci.nsINavBookmarkObserver) ||
					iid.equals(Ci.nsISupports)) {
				  return this;
				}
				throw Cr.NS_ERROR_NO_INTERFACE;
			  },
			};

			// Register the observer with the bookmarks service
			var bmsvc = Cc["@mozilla.org/browser/nav-bookmarks-service;1"]
						.getService(Ci.nsINavBookmarksService);
			bmsvc.addObserver(observer, false);

			// Un-register the observer when done.
			//bmsvc.removeObserver(observer);
		
			LogUtil.log("hookBookmarkService Register END");
		}
	},	
*/	
	